# /usr merge test suite

The steps that this test suite takes to run *each* test are:

1) Create a new Alpine Linux root fs layout for the test

2) (optional) Install a list of packages before executing merge-usr

3) Runs merge-usr on the Alpine test root fs

4) (optional) Install and/or remove packages in the test root fs

5) Validate a list of symlinks in the test root fs match expected targets.

## Running the testsuite

Simply run the `run.sh` script under the `tests` directory

##  Test config format

Tests are added by creating a file: `tests/<test name>.test`

The file contains fields:

- `@PRE_MERGE_PKGS_ADD`: (optional) space-delimited list OR apk world file of packages to **add before** running merge-usr
- `@PRE_CREATE_FILES`: (optional) space-delimited list of files to create in the rootfs **before** running merge-usr.
- `@POST_MERGE_PKGS_DEL`: (optional) space-delimited list of packages to **remove after** running merge-usr. This is run before `POST_MERGE_PKGS_ADD`.
- `@POST_MERGE_PKGS_ADD`: (optional) space-delimited list of packages to **add after** running merge-usr
- `@EXPECT`: newline-delimited list of items, where an item is one of:

1) symlinks and their expected targets after calling merge-usr and adding/removing packages. The symlink path and expected target are separated by a colon `:`. These are used to check that the test's results match expectations. E.g. `/bin:/usr/bin` will check that `/bin` is a symlink to `/usr/bin`.

2) A path to a single file, the existence and validity is checked. This is currently passed to `sh [ -f ]`. E.g. `/usr/bin/busybox` will check that there is a valid file at this path.

See `tests/*.test` for examples.

## Dependencies

- jchroot: For creating rootless chroots

- python: merge-usr is currently implemented in python. This will probably change/go away later
